/* ccm-timeline.c generated by valac 0.12.0, the Vala compiler
 * generated from ccm-timeline.vala, do not modify */

/* -*- Mode: C; indent-tabs-mode: nil; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * ccm-timeline.vala
 * Copyright (C) Nicolas Bruguier 2010 <gandalfn@club-internet.fr>
 * 
 * cairo-compmgr is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * cairo-compmgr is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "ccm-timeline.h"
#include <float.h>
#include <math.h>


#define CCM_TYPE_TIMEOUT (ccm_timeout_get_type ())
#define CCM_TIMEOUT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CCM_TYPE_TIMEOUT, CCMTimeout))
#define CCM_TIMEOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CCM_TYPE_TIMEOUT, CCMTimeoutClass))
#define CCM_IS_TIMEOUT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CCM_TYPE_TIMEOUT))
#define CCM_IS_TIMEOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CCM_TYPE_TIMEOUT))
#define CCM_TIMEOUT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CCM_TYPE_TIMEOUT, CCMTimeoutClass))

typedef struct _CCMTimeout CCMTimeout;
typedef struct _CCMTimeoutClass CCMTimeoutClass;

#define CCM_TYPE_TIMEOUT_POOL (ccm_timeout_pool_get_type ())
#define CCM_TIMEOUT_POOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CCM_TYPE_TIMEOUT_POOL, CCMTimeoutPool))
#define CCM_TIMEOUT_POOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CCM_TYPE_TIMEOUT_POOL, CCMTimeoutPoolClass))
#define CCM_IS_TIMEOUT_POOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CCM_TYPE_TIMEOUT_POOL))
#define CCM_IS_TIMEOUT_POOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CCM_TYPE_TIMEOUT_POOL))
#define CCM_TIMEOUT_POOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CCM_TYPE_TIMEOUT_POOL, CCMTimeoutPoolClass))

typedef struct _CCMTimeoutPool CCMTimeoutPool;
typedef struct _CCMTimeoutPoolClass CCMTimeoutPoolClass;
#define _ccm_timeout_unref0(var) ((var == NULL) ? NULL : (var = (ccm_timeout_unref (var), NULL)))
#define _ccm_timeout_pool_unref0(var) ((var == NULL) ? NULL : (var = (ccm_timeout_pool_unref (var), NULL)))

struct _CCMTimelinePrivate {
	CCMTimeout* m_Timeout;
	CCMTimelineDirection m_Direction;
	gint m_CurrentFrameNum;
	guint m_Fps;
	guint m_NFrames;
	guint m_Duration;
	GTimeVal m_PrevFrameTimeVal;
	guint _n_frames;
	gboolean _master;
	gboolean _loop;
};

typedef gboolean (*CCMTimeoutFunc) (void* inData);

static gpointer ccm_timeline_parent_class = NULL;
static CCMTimeoutPool* ccm_timeline_s_TimeoutPool;
static CCMTimeoutPool* ccm_timeline_s_TimeoutPool = NULL;

gpointer ccm_timeout_ref (gpointer instance);
void ccm_timeout_unref (gpointer instance);
GParamSpec* ccm_param_spec_timeout (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void ccm_value_set_timeout (GValue* value, gpointer v_object);
void ccm_value_take_timeout (GValue* value, gpointer v_object);
gpointer ccm_value_get_timeout (const GValue* value);
GType ccm_timeout_get_type (void) G_GNUC_CONST;
#define CCM_TIMELINE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), CCM_TYPE_TIMELINE, CCMTimelinePrivate))
enum  {
	CCM_TIMELINE_DUMMY_PROPERTY,
	CCM_TIMELINE_DIRECTION,
	CCM_TIMELINE_SPEED,
	CCM_TIMELINE_N_FRAMES,
	CCM_TIMELINE_DURATION,
	CCM_TIMELINE_MASTER,
	CCM_TIMELINE_LOOP,
	CCM_TIMELINE_IS_PLAYING,
	CCM_TIMELINE_CURRENT_FRAME,
	CCM_TIMELINE_PROGRESS
};
gpointer ccm_timeout_pool_ref (gpointer instance);
void ccm_timeout_pool_unref (gpointer instance);
GParamSpec* ccm_param_spec_timeout_pool (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void ccm_value_set_timeout_pool (GValue* value, gpointer v_object);
void ccm_value_take_timeout_pool (GValue* value, gpointer v_object);
gpointer ccm_value_get_timeout_pool (const GValue* value);
GType ccm_timeout_pool_get_type (void) G_GNUC_CONST;
void ccm_timeout_pool_remove (CCMTimeoutPool* self, CCMTimeout* inTimeout);
static void ccm_timeline_add_timeout (CCMTimeline* self);
CCMTimeout* ccm_timeout_pool_add_master (CCMTimeoutPool* self, guint inFps, CCMTimeoutFunc inFunc, void* inData, GDestroyNotify inNotify);
static gboolean ccm_timeline_on_timeout (CCMTimeline* self);
static gboolean _ccm_timeline_on_timeout_ccm_timeout_func (void* inData);
CCMTimeout* ccm_timeout_pool_add (CCMTimeoutPool* self, guint inFps, CCMTimeoutFunc inFunc, void* inData, GDestroyNotify inNotify);
static inline gboolean ccm_timeline_is_complete (CCMTimeline* self);
void ccm_timeout_pool_set_priority (CCMTimeoutPool* self, gint inPriority);
CCMTimeoutPool* ccm_timeout_pool_new (gint inPriority, GMainContext* inContext);
CCMTimeoutPool* ccm_timeout_pool_construct (GType object_type, gint inPriority, GMainContext* inContext);
static void ccm_timeline_finalize (GObject* obj);
static void _vala_ccm_timeline_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_ccm_timeline_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GType ccm_timeline_direction_get_type (void) {
	static volatile gsize ccm_timeline_direction_type_id__volatile = 0;
	if (g_once_init_enter (&ccm_timeline_direction_type_id__volatile)) {
		static const GEnumValue values[] = {{CCM_TIMELINE_DIRECTION_FORWARD, "CCM_TIMELINE_DIRECTION_FORWARD", "forward"}, {CCM_TIMELINE_DIRECTION_BACKWARD, "CCM_TIMELINE_DIRECTION_BACKWARD", "backward"}, {0, NULL, NULL}};
		GType ccm_timeline_direction_type_id;
		ccm_timeline_direction_type_id = g_enum_register_static ("CCMTimelineDirection", values);
		g_once_init_leave (&ccm_timeline_direction_type_id__volatile, ccm_timeline_direction_type_id);
	}
	return ccm_timeline_direction_type_id__volatile;
}


/**
     * Construct a new timeline
     *
     * @param inNbFrames number of frames
     * @param inFps timeline speed in frame per second
     */
CCMTimeline* ccm_timeline_construct (GType object_type, guint inNbFrames, guint inFps) {
	CCMTimeline * self = NULL;
	self = (CCMTimeline*) g_object_new (object_type, "speed", inFps, "n-frames", inNbFrames, NULL);
	return self;
}


CCMTimeline* ccm_timeline_new (guint inNbFrames, guint inFps) {
	return ccm_timeline_construct (CCM_TYPE_TIMELINE, inNbFrames, inFps);
}


/**
     * Construct a new timeline from duration
     *
     * @param inDuration timeline duration
     */
CCMTimeline* ccm_timeline_construct_for_duration (GType object_type, guint inDuration) {
	CCMTimeline * self = NULL;
	self = (CCMTimeline*) g_object_new (object_type, "duration", inDuration, NULL);
	return self;
}


CCMTimeline* ccm_timeline_new_for_duration (guint inDuration) {
	return ccm_timeline_construct_for_duration (CCM_TYPE_TIMELINE, inDuration);
}


static gboolean _ccm_timeline_on_timeout_ccm_timeout_func (void* inData) {
	gboolean result;
	result = ccm_timeline_on_timeout (inData);
	return result;
}


static void ccm_timeline_add_timeout (CCMTimeline* self) {
	g_return_if_fail (self != NULL);
	if (self->priv->m_PrevFrameTimeVal.tv_sec == 0) {
		g_get_current_time (&self->priv->m_PrevFrameTimeVal);
	}
	if (self->priv->_master) {
		CCMTimeout* _tmp0_ = NULL;
		_tmp0_ = ccm_timeout_pool_add_master (ccm_timeline_s_TimeoutPool, self->priv->m_Fps, _ccm_timeline_on_timeout_ccm_timeout_func, self, NULL);
		_ccm_timeout_unref0 (self->priv->m_Timeout);
		self->priv->m_Timeout = _tmp0_;
	} else {
		CCMTimeout* _tmp1_ = NULL;
		_tmp1_ = ccm_timeout_pool_add (ccm_timeline_s_TimeoutPool, self->priv->m_Fps, _ccm_timeline_on_timeout_ccm_timeout_func, self, NULL);
		_ccm_timeout_unref0 (self->priv->m_Timeout);
		self->priv->m_Timeout = _tmp1_;
	}
}


static inline gboolean ccm_timeline_is_complete (CCMTimeline* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (self->priv->m_Direction == CCM_TIMELINE_DIRECTION_FORWARD) {
		_tmp1_ = self->priv->m_CurrentFrameNum >= self->priv->_n_frames;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp2_ = FALSE;
		if (self->priv->m_Direction == CCM_TIMELINE_DIRECTION_BACKWARD) {
			_tmp2_ = self->priv->m_CurrentFrameNum <= 0;
		} else {
			_tmp2_ = FALSE;
		}
		_tmp0_ = _tmp2_;
	}
	result = _tmp0_;
	return result;
}


static gboolean ccm_timeline_on_timeout (CCMTimeline* self) {
	gboolean result = FALSE;
	GTimeVal now = {0};
	guint n_frames = 0U;
	gulong msecs = 0UL;
	gulong speed = 0UL;
	guint _tmp0_;
	gboolean _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_get_current_time (&now);
	g_get_current_time (&now);
	if (self->priv->m_PrevFrameTimeVal.tv_sec == 0) {
		self->priv->m_PrevFrameTimeVal = now;
	}
	if ((now.tv_sec - self->priv->m_PrevFrameTimeVal.tv_sec) < 0) {
		self->priv->m_PrevFrameTimeVal = now;
	}
	msecs = (gulong) ((now.tv_sec - self->priv->m_PrevFrameTimeVal.tv_sec) * 1000);
	msecs = msecs + ((gulong) ((now.tv_usec - self->priv->m_PrevFrameTimeVal.tv_usec) / 1000));
	_tmp0_ = MAX (1000 / self->priv->m_Fps, (guint) 1);
	speed = (gulong) _tmp0_;
	n_frames = (guint) (msecs / speed);
	if (n_frames == 0) {
		n_frames = (guint) 1;
	}
	self->priv->m_PrevFrameTimeVal = now;
	if (self->priv->m_Direction == CCM_TIMELINE_DIRECTION_FORWARD) {
		self->priv->m_CurrentFrameNum = self->priv->m_CurrentFrameNum + ((gint) n_frames);
	} else {
		self->priv->m_CurrentFrameNum = self->priv->m_CurrentFrameNum - ((gint) n_frames);
	}
	_tmp1_ = ccm_timeline_is_complete (self);
	if (!_tmp1_) {
		g_signal_emit_by_name (self, "new-frame", self->priv->m_CurrentFrameNum);
		if (self->priv->m_Timeout == NULL) {
			result = FALSE;
			return result;
		}
		result = TRUE;
		return result;
	} else {
		CCMTimelineDirection saved_direction;
		guint overflow_frame_num;
		gint end_frame = 0;
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		saved_direction = self->priv->m_Direction;
		overflow_frame_num = (guint) self->priv->m_CurrentFrameNum;
		if (self->priv->m_Direction == CCM_TIMELINE_DIRECTION_FORWARD) {
			self->priv->m_CurrentFrameNum = (gint) self->priv->_n_frames;
		} else {
			if (self->priv->m_Direction == CCM_TIMELINE_DIRECTION_BACKWARD) {
				self->priv->m_CurrentFrameNum = 0;
			}
		}
		end_frame = self->priv->m_CurrentFrameNum;
		g_signal_emit_by_name (self, "new-frame", self->priv->m_CurrentFrameNum);
		if (self->priv->m_CurrentFrameNum != end_frame) {
			result = TRUE;
			return result;
		}
		if (!self->priv->_loop) {
			_tmp2_ = self->priv->m_Timeout != NULL;
		} else {
			_tmp2_ = FALSE;
		}
		if (_tmp2_) {
			ccm_timeout_pool_remove (ccm_timeline_s_TimeoutPool, self->priv->m_Timeout);
			_ccm_timeout_unref0 (self->priv->m_Timeout);
			self->priv->m_Timeout = NULL;
		}
		g_signal_emit_by_name (self, "completed");
		if (self->priv->m_CurrentFrameNum != end_frame) {
			gboolean _tmp4_ = FALSE;
			gboolean _tmp5_ = FALSE;
			if (self->priv->m_CurrentFrameNum == 0) {
				_tmp5_ = end_frame == self->priv->_n_frames;
			} else {
				_tmp5_ = FALSE;
			}
			if (_tmp5_) {
				_tmp4_ = TRUE;
			} else {
				gboolean _tmp6_ = FALSE;
				if (self->priv->m_CurrentFrameNum == self->priv->_n_frames) {
					_tmp6_ = end_frame == 0;
				} else {
					_tmp6_ = FALSE;
				}
				_tmp4_ = _tmp6_;
			}
			_tmp3_ = !_tmp4_;
		} else {
			_tmp3_ = FALSE;
		}
		if (_tmp3_) {
			result = TRUE;
			return result;
		}
		if (self->priv->_loop) {
			if (saved_direction == CCM_TIMELINE_DIRECTION_FORWARD) {
				self->priv->m_CurrentFrameNum = (gint) (overflow_frame_num - self->priv->_n_frames);
			} else {
				self->priv->m_CurrentFrameNum = (gint) (self->priv->_n_frames + overflow_frame_num);
			}
			if (self->priv->m_Direction != saved_direction) {
				self->priv->m_CurrentFrameNum = (gint) (self->priv->_n_frames - self->priv->m_CurrentFrameNum);
			}
			result = TRUE;
			return result;
		} else {
			ccm_timeline_rewind (self);
			self->priv->m_PrevFrameTimeVal.tv_sec = (glong) 0;
			self->priv->m_PrevFrameTimeVal.tv_usec = (glong) 0;
			result = FALSE;
			return result;
		}
	}
}


/**
     * Start timeline
     */
void ccm_timeline_start (CCMTimeline* self) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (self->priv->_n_frames > 0);
	if (self->priv->m_Timeout != NULL) {
		return;
	}
	ccm_timeline_add_timeout (self);
	g_signal_emit_by_name (self, "started");
}


/**
     * Pause timeline
     */
void ccm_timeline_pause (CCMTimeline* self) {
	g_return_if_fail (self != NULL);
	if (self->priv->m_Timeout != NULL) {
		ccm_timeout_pool_remove (ccm_timeline_s_TimeoutPool, self->priv->m_Timeout);
		_ccm_timeout_unref0 (self->priv->m_Timeout);
		self->priv->m_Timeout = NULL;
	}
	self->priv->m_PrevFrameTimeVal.tv_sec = (glong) 0;
	self->priv->m_PrevFrameTimeVal.tv_usec = (glong) 0;
	g_signal_emit_by_name (self, "paused");
}


/**
     * Stop timeline
     */
void ccm_timeline_stop (CCMTimeline* self) {
	g_return_if_fail (self != NULL);
	ccm_timeline_pause (self);
	ccm_timeline_rewind (self);
}


/**
     * Rewind timeline to begining
     */
void ccm_timeline_rewind (CCMTimeline* self) {
	g_return_if_fail (self != NULL);
	if (self->priv->m_Direction == CCM_TIMELINE_DIRECTION_FORWARD) {
		ccm_timeline_advance (self, (guint) 0);
	} else {
		if (self->priv->m_Direction == CCM_TIMELINE_DIRECTION_BACKWARD) {
			ccm_timeline_advance (self, self->priv->_n_frames);
		}
	}
}


/**
     * Advance timeline to frame inNumFrame
     *
     * @param inNFrames frame number to advance to
     */
void ccm_timeline_advance (CCMTimeline* self, guint inNumFrame) {
	guint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = CLAMP (inNumFrame, (guint) 0, self->priv->_n_frames);
	self->priv->m_CurrentFrameNum = (gint) _tmp0_;
}


/**
     * Skip inNbFrames 
     *
     * @param inNbFrames number of frames to skip
     */
void ccm_timeline_skip (CCMTimeline* self, gint inNbFrames) {
	g_return_if_fail (self != NULL);
	if (self->priv->m_Direction == CCM_TIMELINE_DIRECTION_FORWARD) {
		self->priv->m_CurrentFrameNum = self->priv->m_CurrentFrameNum + inNbFrames;
		if (self->priv->m_CurrentFrameNum > self->priv->_n_frames) {
			self->priv->m_CurrentFrameNum = 1;
		}
	} else {
		if (self->priv->m_Direction == CCM_TIMELINE_DIRECTION_BACKWARD) {
			self->priv->m_CurrentFrameNum = self->priv->m_CurrentFrameNum - inNbFrames;
			if (self->priv->m_CurrentFrameNum < 1) {
				self->priv->m_CurrentFrameNum = (gint) (self->priv->_n_frames - 1);
			}
		}
	}
}


/**
     * Set timeline timeout pool priority
     *
     * @param inPriority timeout pool priority
     */
void ccm_timeline_set_priority (gint inPriority) {
	ccm_timeout_pool_set_priority (ccm_timeline_s_TimeoutPool, inPriority);
}


CCMTimelineDirection ccm_timeline_get_direction (CCMTimeline* self) {
	CCMTimelineDirection result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->m_Direction;
	return result;
}


void ccm_timeline_set_direction (CCMTimeline* self, CCMTimelineDirection value) {
	g_return_if_fail (self != NULL);
	if (self->priv->m_Direction != value) {
		self->priv->m_Direction = value;
		if (self->priv->m_CurrentFrameNum == 0) {
			self->priv->m_CurrentFrameNum = (gint) self->priv->m_NFrames;
		}
	}
	g_object_notify ((GObject *) self, "direction");
}


guint ccm_timeline_get_speed (CCMTimeline* self) {
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->m_Fps;
	return result;
}


void ccm_timeline_set_speed (CCMTimeline* self, guint value) {
	g_return_if_fail (self != NULL);
	if (self->priv->m_Fps != value) {
		self->priv->m_Fps = value;
		if (self->priv->m_Timeout != NULL) {
			ccm_timeout_pool_remove (ccm_timeline_s_TimeoutPool, self->priv->m_Timeout);
			ccm_timeline_add_timeout (self);
		}
	}
	g_object_notify ((GObject *) self, "speed");
}


guint ccm_timeline_get_n_frames (CCMTimeline* self) {
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_n_frames;
	return result;
}


void ccm_timeline_set_n_frames (CCMTimeline* self, guint value) {
	g_return_if_fail (self != NULL);
	self->priv->_n_frames = value;
	g_object_notify ((GObject *) self, "n-frames");
}


guint ccm_timeline_get_duration (CCMTimeline* self) {
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->m_Duration;
	return result;
}


void ccm_timeline_set_duration (CCMTimeline* self, guint value) {
	g_return_if_fail (self != NULL);
	if (self->priv->m_Duration != value) {
		self->priv->m_Duration = value;
		ccm_timeline_set_n_frames (self, (self->priv->m_Duration * self->priv->m_Fps) / 1000);
	}
	g_object_notify ((GObject *) self, "duration");
}


gboolean ccm_timeline_get_master (CCMTimeline* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_master;
	return result;
}


void ccm_timeline_set_master (CCMTimeline* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_master = value;
	g_object_notify ((GObject *) self, "master");
}


gboolean ccm_timeline_get_loop (CCMTimeline* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_loop;
	return result;
}


void ccm_timeline_set_loop (CCMTimeline* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_loop = value;
	g_object_notify ((GObject *) self, "loop");
}


gboolean ccm_timeline_get_is_playing (CCMTimeline* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->m_Timeout != NULL;
	return result;
}


guint ccm_timeline_get_current_frame (CCMTimeline* self) {
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = (guint) self->priv->m_CurrentFrameNum;
	return result;
}


gdouble ccm_timeline_get_progress (CCMTimeline* self) {
	gdouble result;
	gboolean _tmp0_;
	gdouble _tmp1_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = ccm_timeline_get_is_playing (self);
	if (!_tmp0_) {
		if (self->priv->m_Direction == CCM_TIMELINE_DIRECTION_FORWARD) {
			result = 0.0;
			return result;
		} else {
			result = 1.0;
			return result;
		}
	}
	_tmp1_ = CLAMP (((gdouble) self->priv->m_CurrentFrameNum) / ((gdouble) self->priv->_n_frames), 0.0, 1.0);
	result = _tmp1_;
	return result;
}


static void ccm_timeline_class_init (CCMTimelineClass * klass) {
	CCMTimeoutPool* _tmp0_ = NULL;
	ccm_timeline_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (CCMTimelinePrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_ccm_timeline_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_ccm_timeline_set_property;
	G_OBJECT_CLASS (klass)->finalize = ccm_timeline_finalize;
	/**
	     * Timeline direction
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), CCM_TIMELINE_DIRECTION, g_param_spec_enum ("direction", "direction", "direction", CCM_TYPE_TIMELINE_DIRECTION, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * Timeline speed in frame per second
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), CCM_TIMELINE_SPEED, g_param_spec_uint ("speed", "speed", "speed", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * Number of frame in Timeline 
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), CCM_TIMELINE_N_FRAMES, g_param_spec_uint ("n-frames", "n-frames", "n-frames", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * Timeline duration in msecs
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), CCM_TIMELINE_DURATION, g_param_spec_uint ("duration", "duration", "duration", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * Indicate if timeline is master timeline
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), CCM_TIMELINE_MASTER, g_param_spec_boolean ("master", "master", "master", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * Timeline loop
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), CCM_TIMELINE_LOOP, g_param_spec_boolean ("loop", "loop", "loop", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * Indicate if timeline is currently running
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), CCM_TIMELINE_IS_PLAYING, g_param_spec_boolean ("is-playing", "is-playing", "is-playing", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	     * Current frame
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), CCM_TIMELINE_CURRENT_FRAME, g_param_spec_uint ("current-frame", "current-frame", "current-frame", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	     * Timeline progress 
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), CCM_TIMELINE_PROGRESS, g_param_spec_double ("progress", "progress", "progress", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_signal_new ("started", CCM_TYPE_TIMELINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("paused", CCM_TYPE_TIMELINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("new_frame", CCM_TYPE_TIMELINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
	g_signal_new ("completed", CCM_TYPE_TIMELINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	_tmp0_ = ccm_timeout_pool_new (G_PRIORITY_DEFAULT + 10, NULL);
	_ccm_timeout_pool_unref0 (ccm_timeline_s_TimeoutPool);
	ccm_timeline_s_TimeoutPool = _tmp0_;
}


static void ccm_timeline_instance_init (CCMTimeline * self) {
	self->priv = CCM_TIMELINE_GET_PRIVATE (self);
	self->priv->m_Timeout = NULL;
	self->priv->m_Direction = CCM_TIMELINE_DIRECTION_FORWARD;
	self->priv->m_CurrentFrameNum = 0;
	self->priv->m_Fps = (guint) 60;
	self->priv->m_NFrames = (guint) 0;
	self->priv->m_Duration = (guint) 0;
	self->priv->_n_frames = (guint) 0;
	self->priv->_master = FALSE;
	self->priv->_loop = FALSE;
}


static void ccm_timeline_finalize (GObject* obj) {
	CCMTimeline * self;
	self = CCM_TIMELINE (obj);
	if (self->priv->m_Timeout != NULL) {
		ccm_timeout_pool_remove (ccm_timeline_s_TimeoutPool, self->priv->m_Timeout);
	}
	_ccm_timeout_unref0 (self->priv->m_Timeout);
	G_OBJECT_CLASS (ccm_timeline_parent_class)->finalize (obj);
}


GType ccm_timeline_get_type (void) {
	static volatile gsize ccm_timeline_type_id__volatile = 0;
	if (g_once_init_enter (&ccm_timeline_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CCMTimelineClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ccm_timeline_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CCMTimeline), 0, (GInstanceInitFunc) ccm_timeline_instance_init, NULL };
		GType ccm_timeline_type_id;
		ccm_timeline_type_id = g_type_register_static (G_TYPE_OBJECT, "CCMTimeline", &g_define_type_info, 0);
		g_once_init_leave (&ccm_timeline_type_id__volatile, ccm_timeline_type_id);
	}
	return ccm_timeline_type_id__volatile;
}


static void _vala_ccm_timeline_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	CCMTimeline * self;
	self = CCM_TIMELINE (object);
	switch (property_id) {
		case CCM_TIMELINE_DIRECTION:
		g_value_set_enum (value, ccm_timeline_get_direction (self));
		break;
		case CCM_TIMELINE_SPEED:
		g_value_set_uint (value, ccm_timeline_get_speed (self));
		break;
		case CCM_TIMELINE_N_FRAMES:
		g_value_set_uint (value, ccm_timeline_get_n_frames (self));
		break;
		case CCM_TIMELINE_DURATION:
		g_value_set_uint (value, ccm_timeline_get_duration (self));
		break;
		case CCM_TIMELINE_MASTER:
		g_value_set_boolean (value, ccm_timeline_get_master (self));
		break;
		case CCM_TIMELINE_LOOP:
		g_value_set_boolean (value, ccm_timeline_get_loop (self));
		break;
		case CCM_TIMELINE_IS_PLAYING:
		g_value_set_boolean (value, ccm_timeline_get_is_playing (self));
		break;
		case CCM_TIMELINE_CURRENT_FRAME:
		g_value_set_uint (value, ccm_timeline_get_current_frame (self));
		break;
		case CCM_TIMELINE_PROGRESS:
		g_value_set_double (value, ccm_timeline_get_progress (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_ccm_timeline_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	CCMTimeline * self;
	self = CCM_TIMELINE (object);
	switch (property_id) {
		case CCM_TIMELINE_DIRECTION:
		ccm_timeline_set_direction (self, g_value_get_enum (value));
		break;
		case CCM_TIMELINE_SPEED:
		ccm_timeline_set_speed (self, g_value_get_uint (value));
		break;
		case CCM_TIMELINE_N_FRAMES:
		ccm_timeline_set_n_frames (self, g_value_get_uint (value));
		break;
		case CCM_TIMELINE_DURATION:
		ccm_timeline_set_duration (self, g_value_get_uint (value));
		break;
		case CCM_TIMELINE_MASTER:
		ccm_timeline_set_master (self, g_value_get_boolean (value));
		break;
		case CCM_TIMELINE_LOOP:
		ccm_timeline_set_loop (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



