/* ccm-timeout-interval.c generated by valac 0.12.0, the Vala compiler
 * generated from ccm-timeout-interval.vala, do not modify */

/* -*- Mode: C; indent-tabs-mode: nil; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * ccm-timeout-interval.vala
 * Copyright (C) Nicolas Bruguier 2010 <gandalfn@club-internet.fr>
 * 
 * cairo-compmgr is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * cairo-compmgr is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <string.h>


#define CCM_TYPE_TIMEOUT_INTERVAL (ccm_timeout_interval_get_type ())
typedef struct _CCMTimeoutInterval CCMTimeoutInterval;

typedef gboolean (*CCMTimeoutFunc) (void* inData);
struct _CCMTimeoutInterval {
	GTimeVal m_StartTime;
	guint m_FrameCount;
	guint m_Fps;
};



GType ccm_timeout_interval_get_type (void) G_GNUC_CONST;
CCMTimeoutInterval* ccm_timeout_interval_dup (const CCMTimeoutInterval* self);
void ccm_timeout_interval_free (CCMTimeoutInterval* self);
void ccm_timeout_interval_init (CCMTimeoutInterval *self, guint inFps);
static inline guint ccm_timeout_interval_get_ticks (CCMTimeoutInterval *self, GTimeVal* inCurrentTime);
gboolean ccm_timeout_interval_prepare (CCMTimeoutInterval *self, GTimeVal* inCurrentTime, gint* outDelay);
gboolean ccm_timeout_interval_dispatch (CCMTimeoutInterval *self, CCMTimeoutFunc inCallback, void* inData);
gint ccm_timeout_interval_compare (CCMTimeoutInterval *self, CCMTimeoutInterval* inTimeoutInterval);


void ccm_timeout_interval_init (CCMTimeoutInterval *self, guint inFps) {
	memset (self, 0, sizeof (CCMTimeoutInterval));
	g_get_current_time (&(*self).m_StartTime);
	(*self).m_Fps = inFps;
	(*self).m_FrameCount = (guint) 0;
}


static inline guint ccm_timeout_interval_get_ticks (CCMTimeoutInterval *self, GTimeVal* inCurrentTime) {
	guint result = 0U;
	result = (guint) ((((*inCurrentTime).tv_sec - (*self).m_StartTime.tv_sec) * 1000) + (((*inCurrentTime).tv_usec - (*self).m_StartTime.tv_usec) / 1000));
	return result;
}


gboolean ccm_timeout_interval_prepare (CCMTimeoutInterval *self, GTimeVal* inCurrentTime, gint* outDelay) {
	gint _outDelay = 0;
	gboolean result = FALSE;
	gboolean ret;
	guint _tmp0_;
	guint elapsed_time;
	guint new_frame_num;
	gboolean _tmp1_ = FALSE;
	ret = FALSE;
	_tmp0_ = ccm_timeout_interval_get_ticks (&(*self), inCurrentTime);
	elapsed_time = _tmp0_;
	new_frame_num = (elapsed_time * (*self).m_Fps) / 1000;
	if (new_frame_num < (*self).m_FrameCount) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (new_frame_num - (*self).m_FrameCount) > 2;
	}
	if (_tmp1_) {
		guint frame_time;
		frame_time = ((1000 + (*self).m_Fps) - 1) / (*self).m_Fps;
		(*self).m_StartTime = *inCurrentTime;
		g_time_val_add (&(*self).m_StartTime, (glong) ((-((gint) frame_time)) * 1000));
		(*self).m_FrameCount = (guint) 0;
		_outDelay = 0;
		ret = TRUE;
	} else {
		if (new_frame_num > (*self).m_FrameCount) {
			_outDelay = 0;
			ret = TRUE;
		} else {
			_outDelay = (gint) (((((*self).m_FrameCount + 1) * 1000) / (*self).m_Fps) - elapsed_time);
		}
	}
	result = ret;
	if (outDelay) {
		*outDelay = _outDelay;
	}
	return result;
}


gboolean ccm_timeout_interval_dispatch (CCMTimeoutInterval *self, CCMTimeoutFunc inCallback, void* inData) {
	gboolean result = FALSE;
	gboolean ret;
	gboolean _tmp0_;
	ret = FALSE;
	_tmp0_ = inCallback (inData);
	if (_tmp0_) {
		(*self).m_FrameCount++;
		ret = TRUE;
	}
	result = ret;
	return result;
}


gint ccm_timeout_interval_compare (CCMTimeoutInterval *self, CCMTimeoutInterval* inTimeoutInterval) {
	gint result = 0;
	guint a_delay;
	guint b_delay;
	glong b_difference = 0L;
	gint comparison = 0;
	gint _tmp0_ = 0;
	a_delay = 1000 / (*self).m_Fps;
	b_delay = 1000 / (*inTimeoutInterval).m_Fps;
	b_difference = (((*self).m_StartTime.tv_sec - (*inTimeoutInterval).m_StartTime.tv_sec) * 1000) + (((*self).m_StartTime.tv_usec - (*inTimeoutInterval).m_StartTime.tv_usec) / 1000);
	comparison = ((gint) (((*self).m_FrameCount + 1) * a_delay)) - ((gint) ((((*inTimeoutInterval).m_FrameCount + 1) * b_delay) + b_difference));
	if (comparison < 0) {
		_tmp0_ = -1;
	} else {
		gint _tmp1_ = 0;
		if (comparison > 0) {
			_tmp1_ = 1;
		} else {
			_tmp1_ = 0;
		}
		_tmp0_ = _tmp1_;
	}
	result = _tmp0_;
	return result;
}


CCMTimeoutInterval* ccm_timeout_interval_dup (const CCMTimeoutInterval* self) {
	CCMTimeoutInterval* dup;
	dup = g_new0 (CCMTimeoutInterval, 1);
	memcpy (dup, self, sizeof (CCMTimeoutInterval));
	return dup;
}


void ccm_timeout_interval_free (CCMTimeoutInterval* self) {
	g_free (self);
}


GType ccm_timeout_interval_get_type (void) {
	static volatile gsize ccm_timeout_interval_type_id__volatile = 0;
	if (g_once_init_enter (&ccm_timeout_interval_type_id__volatile)) {
		GType ccm_timeout_interval_type_id;
		ccm_timeout_interval_type_id = g_boxed_type_register_static ("CCMTimeoutInterval", (GBoxedCopyFunc) ccm_timeout_interval_dup, (GBoxedFreeFunc) ccm_timeout_interval_free);
		g_once_init_leave (&ccm_timeout_interval_type_id__volatile, ccm_timeout_interval_type_id);
	}
	return ccm_timeout_interval_type_id__volatile;
}



