/* ccm-watch.c generated by valac 0.12.0, the Vala compiler
 * generated from ccm-watch.vala, do not modify */

/* -*- Mode: C; indent-tabs-mode: nil; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * maia-watch.vala
 * Copyright (C) Nicolas Bruguier 2010 <gandalfn@club-internet.fr>
 * 
 * libmaia is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * maiawm is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include "ccm-watch.h"
#include <ccm-source.h>
#include <string.h>

#define _ccm_source_unref0(var) ((var == NULL) ? NULL : (var = (ccm_source_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))

struct _CCMWatchPrivate {
	CCMSource* m_Source;
	GPollFD* m_Fd;
};


static gpointer ccm_watch_parent_class = NULL;

#define CCM_WATCH_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), CCM_TYPE_WATCH, CCMWatchPrivate))
enum  {
	CCM_WATCH_DUMMY_PROPERTY
};
static gboolean ccm_watch_on_source_prepare (CCMWatch* self, gint* inTimeout);
static gboolean ccm_watch_on_source_check (CCMWatch* self);
static gboolean ccm_watch_on_source_dispatch (CCMWatch* self, GSourceFunc inCallback, void* inCallback_target);
static void ccm_watch_real_process_watch (CCMWatch* self);
static gboolean _ccm_watch_on_source_prepare_ccm_source_prepare_func (void* inData, gint* outTimeout);
static gboolean _ccm_watch_on_source_check_ccm_source_check_func (void* inData);
static gboolean _ccm_watch_on_source_dispatch_ccm_source_dispatch_func (void* inData, GSourceFunc inCallback, void* inCallback_target);
static GPollFD* _g_poll_fd_dup (GPollFD* self);
static void ccm_watch_finalize (GObject* obj);


static gboolean ccm_watch_on_source_prepare (CCMWatch* self, gint* inTimeout) {
	gint _inTimeout = 0;
	gboolean result = FALSE;
	gboolean ret;
	g_return_val_if_fail (self != NULL, FALSE);
	ret = FALSE;
	_inTimeout = -1;
	ccm_watch_process_watch (self);
	result = ret;
	if (inTimeout) {
		*inTimeout = _inTimeout;
	}
	return result;
}


static gboolean ccm_watch_on_source_check (CCMWatch* self) {
	gboolean result = FALSE;
	gboolean ret;
	g_return_val_if_fail (self != NULL, FALSE);
	ret = FALSE;
	if (((*self->priv->m_Fd).revents & G_IO_NVAL) == G_IO_NVAL) {
		_ccm_source_unref0 (self->priv->m_Source);
		self->priv->m_Source = NULL;
	} else {
		if (((*self->priv->m_Fd).revents & G_IO_IN) == G_IO_IN) {
			ccm_watch_process_watch (self);
			ret = TRUE;
		}
	}
	result = ret;
	return result;
}


static gboolean ccm_watch_on_source_dispatch (CCMWatch* self, GSourceFunc inCallback, void* inCallback_target) {
	gboolean result = FALSE;
	gboolean ret;
	g_return_val_if_fail (self != NULL, FALSE);
	ret = FALSE;
	if (((*self->priv->m_Fd).revents & G_IO_IN) == G_IO_IN) {
		ccm_watch_process_watch (self);
		ret = TRUE;
	}
	result = ret;
	return result;
}


static void ccm_watch_real_process_watch (CCMWatch* self) {
	g_return_if_fail (self != NULL);
	g_critical ("Type `%s' does not implement abstract method `ccm_watch_process_watch'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


void ccm_watch_process_watch (CCMWatch* self) {
	CCM_WATCH_GET_CLASS (self)->process_watch (self);
}


static gboolean _ccm_watch_on_source_prepare_ccm_source_prepare_func (void* inData, gint* outTimeout) {
	gboolean result;
	result = ccm_watch_on_source_prepare (inData, outTimeout);
	return result;
}


static gboolean _ccm_watch_on_source_check_ccm_source_check_func (void* inData) {
	gboolean result;
	result = ccm_watch_on_source_check (inData);
	return result;
}


static gboolean _ccm_watch_on_source_dispatch_ccm_source_dispatch_func (void* inData, GSourceFunc inCallback, void* inCallback_target) {
	gboolean result;
	result = ccm_watch_on_source_dispatch (inData, inCallback, inCallback_target);
	return result;
}


static GPollFD* _g_poll_fd_dup (GPollFD* self) {
	GPollFD* dup;
	dup = g_new0 (GPollFD, 1);
	memcpy (dup, self, sizeof (GPollFD));
	return dup;
}


static gpointer __g_poll_fd_dup0 (gpointer self) {
	return self ? _g_poll_fd_dup (self) : NULL;
}


void ccm_watch_watch (CCMWatch* self, gint inFd, GMainContext* inContext) {
	CCMSourceFuncs _tmp0_;
	CCMSourceFuncs funcs;
	GPollFD _tmp1_ = {0};
	GPollFD _tmp2_ = {0};
	GPollFD* _tmp3_;
	CCMSource* _tmp4_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_.prepare = _ccm_watch_on_source_prepare_ccm_source_prepare_func;
	_tmp0_.check = _ccm_watch_on_source_check_ccm_source_check_func;
	_tmp0_.dispatch = _ccm_watch_on_source_dispatch_ccm_source_dispatch_func;
	_tmp0_.finalize = NULL;
	funcs = _tmp0_;
	memset (&_tmp1_, 0, sizeof (GPollFD));
	_tmp2_ = _tmp1_;
	_tmp3_ = __g_poll_fd_dup0 (&_tmp2_);
	_g_free0 (self->priv->m_Fd);
	self->priv->m_Fd = _tmp3_;
	(*self->priv->m_Fd).fd = inFd;
	(*self->priv->m_Fd).events = G_IO_IN;
	_tmp4_ = ccm_source_new_from_pollfd (funcs, self->priv->m_Fd, self);
	_ccm_source_unref0 (self->priv->m_Source);
	self->priv->m_Source = _tmp4_;
	g_source_attach ((GSource*) self->priv->m_Source, inContext);
	ccm_source_unref (self->priv->m_Source);
}


CCMWatch* ccm_watch_construct (GType object_type) {
	CCMWatch * self = NULL;
	self = (CCMWatch*) g_object_new (object_type, NULL);
	return self;
}


static void ccm_watch_class_init (CCMWatchClass * klass) {
	ccm_watch_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (CCMWatchPrivate));
	CCM_WATCH_CLASS (klass)->process_watch = ccm_watch_real_process_watch;
	G_OBJECT_CLASS (klass)->finalize = ccm_watch_finalize;
}


static void ccm_watch_instance_init (CCMWatch * self) {
	self->priv = CCM_WATCH_GET_PRIVATE (self);
	self->priv->m_Source = NULL;
	self->priv->m_Fd = NULL;
}


static void ccm_watch_finalize (GObject* obj) {
	CCMWatch * self;
	self = CCM_WATCH (obj);
	_ccm_source_unref0 (self->priv->m_Source);
	_g_free0 (self->priv->m_Fd);
	G_OBJECT_CLASS (ccm_watch_parent_class)->finalize (obj);
}


GType ccm_watch_get_type (void) {
	static volatile gsize ccm_watch_type_id__volatile = 0;
	if (g_once_init_enter (&ccm_watch_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CCMWatchClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ccm_watch_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CCMWatch), 0, (GInstanceInitFunc) ccm_watch_instance_init, NULL };
		GType ccm_watch_type_id;
		ccm_watch_type_id = g_type_register_static (G_TYPE_OBJECT, "CCMWatch", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&ccm_watch_type_id__volatile, ccm_watch_type_id);
	}
	return ccm_watch_type_id__volatile;
}



