/* ccm-automate-dialog.c generated by valac 0.12.0, the Vala compiler
 * generated from ccm-automate-dialog.vala, do not modify */

/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * cairo-compmgr
 * Copyright (C) Nicolas Bruguier 2008 <gandalfn@club-internet.fr>
 * 
 * cairo-compmgr is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * cairo-compmgr is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with cairo-compmgr.  If not, write to:
 * 	The Free Software Foundation, Inc.,
 * 	51 Franklin Street, Fifth Floor
 * 	Boston, MA  02110-1301, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include "gdk/gdkx.h"
#include <gdk/gdk.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>
#include <ccm.h>
#include <ccm-screen.h>
#include <ccm-timeline.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <config.h>
#include <float.h>
#include <math.h>
#include <cairo.h>
#include <ccm-cairo-utils.h>
#include <ccm-window.h>
#include <ccm-window-plugin.h>
#include <stdio.h>
#include <ccm-debug.h>


#define CCM_TYPE_AUTOMATE_DIALOG (ccm_automate_dialog_get_type ())
#define CCM_AUTOMATE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CCM_TYPE_AUTOMATE_DIALOG, CCMAutomateDialog))
#define CCM_AUTOMATE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CCM_TYPE_AUTOMATE_DIALOG, CCMAutomateDialogClass))
#define CCM_IS_AUTOMATE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CCM_TYPE_AUTOMATE_DIALOG))
#define CCM_IS_AUTOMATE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CCM_TYPE_AUTOMATE_DIALOG))
#define CCM_AUTOMATE_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CCM_TYPE_AUTOMATE_DIALOG, CCMAutomateDialogClass))

typedef struct _CCMAutomateDialog CCMAutomateDialog;
typedef struct _CCMAutomateDialogClass CCMAutomateDialogClass;
typedef struct _CCMAutomateDialogPrivate CCMAutomateDialogPrivate;

#define CCM_TYPE_STORY_BOARD (ccm_story_board_get_type ())
#define CCM_STORY_BOARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CCM_TYPE_STORY_BOARD, CCMStoryBoard))
#define CCM_STORY_BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CCM_TYPE_STORY_BOARD, CCMStoryBoardClass))
#define CCM_IS_STORY_BOARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CCM_TYPE_STORY_BOARD))
#define CCM_IS_STORY_BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CCM_TYPE_STORY_BOARD))
#define CCM_STORY_BOARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CCM_TYPE_STORY_BOARD, CCMStoryBoardClass))

typedef struct _CCMStoryBoard CCMStoryBoard;
typedef struct _CCMStoryBoardClass CCMStoryBoardClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _CCMAutomateDialog {
	GObject parent_instance;
	CCMAutomateDialogPrivate * priv;
};

struct _CCMAutomateDialogClass {
	GObjectClass parent_class;
};

struct _CCMAutomateDialogPrivate {
	CCMScreen* screen;
	CCMTimeline* timeline;
	GtkWindow* main;
	GtkWidget* close;
	GtkImage* close_image;
	GtkCheckButton* hint_motion;
	CCMStoryBoard* story_board;
};


static gpointer ccm_automate_dialog_parent_class = NULL;
static GType ccm_automate_dialog_type_id = 0;

GType ccm_automate_dialog_get_type (void) G_GNUC_CONST;
GType ccm_automate_dialog_register_type (GTypeModule * module);
GType ccm_story_board_get_type (void) G_GNUC_CONST;
GType ccm_story_board_register_type (GTypeModule * module);
#define CCM_AUTOMATE_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), CCM_TYPE_AUTOMATE_DIALOG, CCMAutomateDialogPrivate))
enum  {
	CCM_AUTOMATE_DIALOG_DUMMY_PROPERTY
};
#define CCM_AUTOMATE_DIALOG_UI_FILE UI_DIR "/ccm-automate.ui"
CCMAutomateDialog* ccm_automate_dialog_new (CCMScreen* screen);
CCMAutomateDialog* ccm_automate_dialog_construct (GType object_type, CCMScreen* screen);
static void ccm_automate_dialog_on_new_frame (CCMAutomateDialog* self, CCMTimeline* timeline, gint num_frame);
static void _ccm_automate_dialog_on_new_frame_ccm_timeline_new_frame (CCMTimeline* _sender, gint inNumFrame, gpointer self);
static void ccm_automate_dialog_on_completed (CCMAutomateDialog* self, CCMTimeline* timeline);
static void _ccm_automate_dialog_on_completed_ccm_timeline_completed (CCMTimeline* _sender, gpointer self);
static void ccm_automate_dialog_construct_ui (CCMAutomateDialog* self);
static void ccm_automate_dialog_on_realize (CCMAutomateDialog* self, GtkWidget* widget);
static gboolean ccm_automate_dialog_on_expose_event (CCMAutomateDialog* self, GtkWidget* widget, GdkEventExpose* event);
static gboolean ccm_automate_dialog_on_close (CCMAutomateDialog* self, GtkWidget* widget, GdkEventButton* event);
static void ccm_automate_dialog_on_record_clicked (CCMAutomateDialog* self, GtkButton* button);
CCMStoryBoard* ccm_story_board_new (CCMScreen* screen, const gchar* name, GList* ignore);
CCMStoryBoard* ccm_story_board_construct (GType object_type, CCMScreen* screen, const gchar* name, GList* ignore);
void ccm_story_board_set_hint_motion (CCMStoryBoard* self, gboolean value);
static void ccm_automate_dialog_on_stop_clicked (CCMAutomateDialog* self, GtkButton* button);
gchar* ccm_story_board_to_string (CCMStoryBoard* self, const gchar* format);
static void _ccm_automate_dialog_on_realize_gtk_widget_realize (GtkWidget* _sender, gpointer self);
static gboolean _ccm_automate_dialog_on_expose_event_gtk_widget_expose_event (GtkWidget* _sender, GdkEventExpose* event, gpointer self);
static gboolean _ccm_automate_dialog_on_close_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static void _ccm_automate_dialog_on_record_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void _ccm_automate_dialog_on_stop_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self);
void ccm_automate_dialog_show (CCMAutomateDialog* self);
void ccm_automate_dialog_hide (CCMAutomateDialog* self);
static void ccm_automate_dialog_finalize (GObject* obj);


static void _ccm_automate_dialog_on_new_frame_ccm_timeline_new_frame (CCMTimeline* _sender, gint inNumFrame, gpointer self) {
	ccm_automate_dialog_on_new_frame (self, _sender, inNumFrame);
}


static void _ccm_automate_dialog_on_completed_ccm_timeline_completed (CCMTimeline* _sender, gpointer self) {
	ccm_automate_dialog_on_completed (self, _sender);
}


CCMAutomateDialog* ccm_automate_dialog_construct (GType object_type, CCMScreen* screen) {
	CCMAutomateDialog * self = NULL;
	CCMTimeline* _tmp0_ = NULL;
	g_return_val_if_fail (screen != NULL, NULL);
	self = (CCMAutomateDialog*) g_object_new (object_type, NULL);
	self->priv->screen = screen;
	_tmp0_ = ccm_timeline_new ((guint) 10, (guint) 60);
	_g_object_unref0 (self->priv->timeline);
	self->priv->timeline = _tmp0_;
	ccm_timeline_set_direction (self->priv->timeline, CCM_TIMELINE_DIRECTION_BACKWARD);
	g_signal_connect_object (self->priv->timeline, "new-frame", (GCallback) _ccm_automate_dialog_on_new_frame_ccm_timeline_new_frame, self, 0);
	g_signal_connect_object (self->priv->timeline, "completed", (GCallback) _ccm_automate_dialog_on_completed_ccm_timeline_completed, self, 0);
	ccm_automate_dialog_construct_ui (self);
	return self;
}


CCMAutomateDialog* ccm_automate_dialog_new (CCMScreen* screen) {
	return ccm_automate_dialog_construct (CCM_TYPE_AUTOMATE_DIALOG, screen);
}


static void ccm_automate_dialog_on_new_frame (CCMAutomateDialog* self, CCMTimeline* timeline, gint num_frame) {
	gint width = 0;
	gint height = 0;
	gint x = 0;
	gint y = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gdouble _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (timeline != NULL);
	gdk_window_get_origin (((GtkWidget*) self->priv->main)->window, &_tmp0_, &_tmp1_);
	x = _tmp0_;
	y = _tmp1_;
	gdk_drawable_get_size ((GdkDrawable*) ((GtkWidget*) self->priv->main)->window, &_tmp2_, &_tmp3_);
	width = _tmp2_;
	height = _tmp3_;
	height = height - self->priv->close->allocation.height;
	_tmp4_ = ccm_timeline_get_progress (timeline);
	gtk_window_move (self->priv->main, x, -((gint) (((gdouble) height) * _tmp4_)));
}


static void ccm_automate_dialog_on_completed (CCMAutomateDialog* self, CCMTimeline* timeline) {
	gchar* stock = NULL;
	CCMTimelineDirection _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (timeline != NULL);
	_tmp0_ = ccm_timeline_get_direction (timeline);
	if (_tmp0_ == CCM_TIMELINE_DIRECTION_FORWARD) {
		gchar* _tmp1_;
		_tmp1_ = g_strdup (GTK_STOCK_GO_DOWN);
		_g_free0 (stock);
		stock = _tmp1_;
	} else {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (GTK_STOCK_GO_UP);
		_g_free0 (stock);
		stock = _tmp2_;
	}
	gtk_image_set_from_stock (self->priv->close_image, stock, GTK_ICON_SIZE_BUTTON);
	_g_free0 (stock);
}


static void ccm_automate_dialog_on_realize (CCMAutomateDialog* self, GtkWidget* widget) {
	gint width = 0;
	gint height = 0;
	GdkAtom _tmp0_;
	GdkAtom atom_enable;
	guchar* _tmp1_ = NULL;
	guchar* enable;
	gint enable_length1;
	gint _enable_size_;
	Atom _tmp2_;
	GdkAtom _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	Screen* _tmp6_ = NULL;
	GdkPixmap* _tmp7_ = NULL;
	GdkPixmap* pixmap;
	cairo_t* _tmp8_ = NULL;
	cairo_t* ctx;
	cairo_surface_t* _tmp9_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	_tmp0_ = gdk_atom_intern_static_string ("_CCM_SHADOW_ENABLED");
	atom_enable = _tmp0_;
	_tmp1_ = g_new0 (guchar, 1);
	_tmp1_[0] = (guchar) 1;
	enable = _tmp1_;
	enable_length1 = 1;
	_enable_size_ = 1;
	_tmp2_ = gdk_x11_get_xatom_by_name ("CARDINAL");
	_tmp3_ = gdk_x11_xatom_to_atom (_tmp2_);
	gdk_property_change (((GtkWidget*) self->priv->main)->window, atom_enable, _tmp3_, 32, GDK_PROP_MODE_REPLACE, enable, 1);
	gdk_drawable_get_size ((GdkDrawable*) ((GtkWidget*) self->priv->main)->window, &_tmp4_, &_tmp5_);
	width = _tmp4_;
	height = _tmp5_;
	gdk_window_set_override_redirect (((GtkWidget*) self->priv->main)->window, TRUE);
	_tmp6_ = ccm_screen_get_xscreen (self->priv->screen);
	gtk_window_move (self->priv->main, (_tmp6_->width / 2) - (width / 2), 0);
	_tmp7_ = gdk_pixmap_new (NULL, width, height, 1);
	pixmap = _tmp7_;
	_tmp8_ = gdk_cairo_create ((GdkDrawable*) pixmap);
	ctx = _tmp8_;
	cairo_set_operator (ctx, CAIRO_OPERATOR_SOURCE);
	cairo_set_source_rgba (ctx, (gdouble) 0, (gdouble) 0, (gdouble) 0, (gdouble) 0);
	cairo_paint (ctx);
	cairo_set_operator (ctx, CAIRO_OPERATOR_OVER);
	cairo_translate (ctx, (gdouble) (width / 2), (gdouble) (height / 2));
	cairo_rotate (ctx, -M_PI);
	cairo_translate (ctx, (gdouble) ((-width) / 2), (gdouble) ((-height) / 2));
	cairo_set_source_rgba (ctx, (gdouble) 1, (gdouble) 1, (gdouble) 1, (gdouble) 1);
	cairo_notebook_page_round ((cairo_t*) ctx, (gdouble) 0, (gdouble) 0, (gdouble) width, (gdouble) height, (gdouble) 0, (gdouble) self->priv->close->allocation.width, (gdouble) self->priv->close->allocation.height, 6);
	cairo_fill (ctx);
	_tmp9_ = cairo_get_target (ctx);
	cairo_surface_finish (_tmp9_);
	gdk_window_shape_combine_mask (widget->window, (GdkBitmap*) NULL, 0, 0);
	gdk_window_input_shape_combine_mask (widget->window, (GdkBitmap*) NULL, 0, 0);
	gdk_window_shape_combine_mask (widget->window, (GdkBitmap*) pixmap, 0, 0);
	gdk_window_input_shape_combine_mask (widget->window, (GdkBitmap*) pixmap, 0, 0);
	_cairo_destroy0 (ctx);
	_g_object_unref0 (pixmap);
	enable = (g_free (enable), NULL);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gboolean ccm_automate_dialog_on_expose_event (CCMAutomateDialog* self, GtkWidget* widget, GdkEventExpose* event) {
	gboolean result = FALSE;
	cairo_t* _tmp0_ = NULL;
	cairo_t* ctx;
	gint width = 0;
	gint height = 0;
	gint _tmp1_;
	gint _tmp2_;
	GtkStyle* _tmp3_ = NULL;
	GtkStyle* _tmp4_ = NULL;
	GtkStyle* _tmp5_ = NULL;
	GtkStyle* _tmp6_ = NULL;
	GtkStyle* _tmp7_ = NULL;
	GtkStyle* _tmp8_ = NULL;
	GtkWidget* _tmp9_ = NULL;
	GtkWidget* _tmp10_;
	GtkWidget* child;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	_tmp0_ = gdk_cairo_create ((GdkDrawable*) widget->window);
	ctx = _tmp0_;
	gdk_drawable_get_size ((GdkDrawable*) widget->window, &_tmp1_, &_tmp2_);
	width = _tmp1_;
	height = _tmp2_;
	cairo_set_operator (ctx, CAIRO_OPERATOR_CLEAR);
	cairo_paint (ctx);
	cairo_set_operator (ctx, CAIRO_OPERATOR_OVER);
	cairo_translate (ctx, (gdouble) (width / 2), (gdouble) (height / 2));
	cairo_rotate (ctx, -M_PI);
	cairo_translate (ctx, (gdouble) ((-width) / 2), (gdouble) ((-height) / 2));
	_tmp3_ = gtk_widget_get_style (widget);
	_tmp4_ = gtk_widget_get_style (widget);
	_tmp5_ = gtk_widget_get_style (widget);
	cairo_set_source_rgba (ctx, ((gdouble) _tmp3_->bg[GTK_STATE_NORMAL].red) / 65535, ((gdouble) _tmp4_->bg[GTK_STATE_NORMAL].green) / 65535, ((gdouble) _tmp5_->bg[GTK_STATE_NORMAL].blue) / 65535, 0.85);
	cairo_notebook_page_round ((cairo_t*) ctx, (gdouble) 0, (gdouble) 0, (gdouble) width, (gdouble) height, (gdouble) 0, (gdouble) self->priv->close->allocation.width, (gdouble) self->priv->close->allocation.height, 6);
	cairo_fill (ctx);
	_tmp6_ = gtk_widget_get_style (widget);
	_tmp7_ = gtk_widget_get_style (widget);
	_tmp8_ = gtk_widget_get_style (widget);
	cairo_set_source_rgba (ctx, ((gdouble) _tmp6_->bg[GTK_STATE_SELECTED].red) / 65535, ((gdouble) _tmp7_->bg[GTK_STATE_SELECTED].green) / 65535, ((gdouble) _tmp8_->bg[GTK_STATE_SELECTED].blue) / 65535, (gdouble) 1);
	cairo_notebook_page_round ((cairo_t*) ctx, (gdouble) 0, (gdouble) 0, (gdouble) width, (gdouble) height, (gdouble) 0, (gdouble) self->priv->close->allocation.width, (gdouble) self->priv->close->allocation.height, 6);
	cairo_stroke (ctx);
	_tmp9_ = gtk_bin_get_child ((GtkBin*) GTK_WINDOW (widget));
	_tmp10_ = _g_object_ref0 (_tmp9_);
	child = _tmp10_;
	gtk_container_propagate_expose (GTK_CONTAINER (widget), child, event);
	result = TRUE;
	_g_object_unref0 (child);
	_cairo_destroy0 (ctx);
	return result;
}


static gboolean ccm_automate_dialog_on_close (CCMAutomateDialog* self, GtkWidget* widget, GdkEventButton* event) {
	gboolean result = FALSE;
	CCMTimelineDirection _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	_tmp0_ = ccm_timeline_get_direction (self->priv->timeline);
	if (_tmp0_ == CCM_TIMELINE_DIRECTION_FORWARD) {
		ccm_timeline_set_direction (self->priv->timeline, CCM_TIMELINE_DIRECTION_BACKWARD);
	} else {
		ccm_timeline_set_direction (self->priv->timeline, CCM_TIMELINE_DIRECTION_FORWARD);
	}
	ccm_timeline_stop (self->priv->timeline);
	ccm_timeline_start (self->priv->timeline);
	result = FALSE;
	return result;
}


static void ccm_automate_dialog_on_record_clicked (CCMAutomateDialog* self, GtkButton* button) {
	Window _tmp0_;
	Window xwindow;
	GList* ignore;
	CCMWindow* _tmp1_ = NULL;
	CCMWindow* window;
	CCMStoryBoard* _tmp2_ = NULL;
	gboolean _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (button != NULL);
	_tmp0_ = GDK_WINDOW_XWINDOW (((GtkWidget*) self->priv->main)->window);
	xwindow = _tmp0_;
	ignore = NULL;
	_tmp1_ = ccm_screen_find_window (self->priv->screen, xwindow);
	window = _tmp1_;
	ignore = g_list_append (ignore, window);
	_tmp2_ = ccm_story_board_new (self->priv->screen, "test", ignore);
	_g_object_unref0 (self->priv->story_board);
	self->priv->story_board = _tmp2_;
	_tmp3_ = gtk_toggle_button_get_active ((GtkToggleButton*) self->priv->hint_motion);
	ccm_story_board_set_hint_motion (self->priv->story_board, _tmp3_);
	_g_list_free0 (ignore);
}


static void ccm_automate_dialog_on_stop_clicked (CCMAutomateDialog* self, GtkButton* button) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (button != NULL);
	if (self->priv->story_board != NULL) {
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		_tmp0_ = ccm_story_board_to_string (self->priv->story_board, "%ccmsb");
		_tmp1_ = _tmp0_;
		fprintf (stdout, "%s", _tmp1_);
		_g_free0 (_tmp1_);
	}
	_g_object_unref0 (self->priv->story_board);
	self->priv->story_board = NULL;
}


static void _ccm_automate_dialog_on_realize_gtk_widget_realize (GtkWidget* _sender, gpointer self) {
	ccm_automate_dialog_on_realize (self, _sender);
}


static gboolean _ccm_automate_dialog_on_expose_event_gtk_widget_expose_event (GtkWidget* _sender, GdkEventExpose* event, gpointer self) {
	gboolean result;
	result = ccm_automate_dialog_on_expose_event (self, _sender, event);
	return result;
}


static gboolean _ccm_automate_dialog_on_close_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = ccm_automate_dialog_on_close (self, _sender, event);
	return result;
}


static void _ccm_automate_dialog_on_record_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self) {
	ccm_automate_dialog_on_record_clicked (self, _sender);
}


static void _ccm_automate_dialog_on_stop_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self) {
	ccm_automate_dialog_on_stop_clicked (self, _sender);
}


static void ccm_automate_dialog_construct_ui (CCMAutomateDialog* self) {
	GtkBuilder* _tmp0_ = NULL;
	GtkBuilder* builder;
	GObject* _tmp1_ = NULL;
	GObject* _tmp2_;
	GtkWindow* _tmp3_;
	GdkScreen* _tmp4_ = NULL;
	GdkScreen* _tmp5_;
	GdkScreen* screen;
	GdkColormap* _tmp6_ = NULL;
	GdkColormap* _tmp7_;
	GdkColormap* colormap;
	GObject* _tmp8_ = NULL;
	GObject* _tmp9_;
	GtkWidget* _tmp10_;
	GObject* _tmp11_ = NULL;
	GObject* _tmp12_;
	GtkImage* _tmp13_;
	GObject* _tmp14_ = NULL;
	GObject* _tmp15_;
	GtkButton* _tmp16_;
	GtkButton* record;
	GObject* _tmp17_ = NULL;
	GObject* _tmp18_;
	GtkButton* _tmp19_;
	GtkButton* stop;
	GObject* _tmp20_ = NULL;
	GObject* _tmp21_;
	GtkCheckButton* _tmp22_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_builder_new ();
	builder = _tmp0_;
	gtk_builder_add_from_file (builder, CCM_AUTOMATE_DIALOG_UI_FILE, &_inner_error_);
	if (_inner_error_ != NULL) {
		_g_object_unref0 (builder);
		goto __catch2_g_error;
	}
	_tmp1_ = gtk_builder_get_object (builder, "main");
	_tmp2_ = _tmp1_;
	_tmp3_ = _g_object_ref0 (GTK_IS_WINDOW (_tmp2_) ? ((GtkWindow*) _tmp2_) : NULL);
	_g_object_unref0 (self->priv->main);
	self->priv->main = _tmp3_;
	gtk_window_set_keep_above (self->priv->main, TRUE);
	_tmp4_ = gdk_screen_get_default ();
	_tmp5_ = _g_object_ref0 (_tmp4_);
	screen = _tmp5_;
	_tmp6_ = gdk_screen_get_rgba_colormap (screen);
	_tmp7_ = _g_object_ref0 (_tmp6_);
	colormap = _tmp7_;
	gtk_widget_set_colormap ((GtkWidget*) self->priv->main, colormap);
	g_signal_connect_object (GTK_WIDGET (self->priv->main), "realize", (GCallback) _ccm_automate_dialog_on_realize_gtk_widget_realize, self, 0);
	g_signal_connect_object (GTK_WIDGET (self->priv->main), "expose-event", (GCallback) _ccm_automate_dialog_on_expose_event_gtk_widget_expose_event, self, 0);
	_tmp8_ = gtk_builder_get_object (builder, "close");
	_tmp9_ = _tmp8_;
	_tmp10_ = _g_object_ref0 (GTK_IS_WIDGET (_tmp9_) ? ((GtkWidget*) _tmp9_) : NULL);
	_g_object_unref0 (self->priv->close);
	self->priv->close = _tmp10_;
	g_signal_connect_object (self->priv->close, "button-press-event", (GCallback) _ccm_automate_dialog_on_close_gtk_widget_button_press_event, self, 0);
	_tmp11_ = gtk_builder_get_object (builder, "close_image");
	_tmp12_ = _tmp11_;
	_tmp13_ = _g_object_ref0 (GTK_IS_IMAGE (_tmp12_) ? ((GtkImage*) _tmp12_) : NULL);
	_g_object_unref0 (self->priv->close_image);
	self->priv->close_image = _tmp13_;
	_tmp14_ = gtk_builder_get_object (builder, "record");
	_tmp15_ = _tmp14_;
	_tmp16_ = _g_object_ref0 (GTK_IS_BUTTON (_tmp15_) ? ((GtkButton*) _tmp15_) : NULL);
	record = _tmp16_;
	g_signal_connect_object (record, "clicked", (GCallback) _ccm_automate_dialog_on_record_clicked_gtk_button_clicked, self, 0);
	_tmp17_ = gtk_builder_get_object (builder, "stop");
	_tmp18_ = _tmp17_;
	_tmp19_ = _g_object_ref0 (GTK_IS_BUTTON (_tmp18_) ? ((GtkButton*) _tmp18_) : NULL);
	stop = _tmp19_;
	g_signal_connect_object (stop, "clicked", (GCallback) _ccm_automate_dialog_on_stop_clicked_gtk_button_clicked, self, 0);
	_tmp20_ = gtk_builder_get_object (builder, "hint_motion");
	_tmp21_ = _tmp20_;
	_tmp22_ = _g_object_ref0 (GTK_IS_CHECK_BUTTON (_tmp21_) ? ((GtkCheckButton*) _tmp21_) : NULL);
	_g_object_unref0 (self->priv->hint_motion);
	self->priv->hint_motion = _tmp22_;
	_g_object_unref0 (stop);
	_g_object_unref0 (record);
	_g_object_unref0 (colormap);
	_g_object_unref0 (screen);
	_g_object_unref0 (builder);
	goto __finally2;
	__catch2_g_error:
	{
		GError * ex;
		ex = _inner_error_;
		_inner_error_ = NULL;
		ccm_log ("Error on create automate dialog: %s", ex->message, NULL);
		_g_error_free0 (ex);
	}
	__finally2:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


void ccm_automate_dialog_show (CCMAutomateDialog* self) {
	g_return_if_fail (self != NULL);
	gtk_widget_show ((GtkWidget*) self->priv->main);
}


void ccm_automate_dialog_hide (CCMAutomateDialog* self) {
	g_return_if_fail (self != NULL);
	gtk_widget_hide ((GtkWidget*) self->priv->main);
}


static void ccm_automate_dialog_class_init (CCMAutomateDialogClass * klass) {
	ccm_automate_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (CCMAutomateDialogPrivate));
	G_OBJECT_CLASS (klass)->finalize = ccm_automate_dialog_finalize;
}


static void ccm_automate_dialog_instance_init (CCMAutomateDialog * self) {
	self->priv = CCM_AUTOMATE_DIALOG_GET_PRIVATE (self);
}


static void ccm_automate_dialog_finalize (GObject* obj) {
	CCMAutomateDialog * self;
	self = CCM_AUTOMATE_DIALOG (obj);
	gtk_object_destroy ((GtkObject*) self->priv->main);
	_g_object_unref0 (self->priv->timeline);
	_g_object_unref0 (self->priv->main);
	_g_object_unref0 (self->priv->close);
	_g_object_unref0 (self->priv->close_image);
	_g_object_unref0 (self->priv->hint_motion);
	_g_object_unref0 (self->priv->story_board);
	G_OBJECT_CLASS (ccm_automate_dialog_parent_class)->finalize (obj);
}


GType ccm_automate_dialog_get_type (void) {
	return ccm_automate_dialog_type_id;
}


GType ccm_automate_dialog_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (CCMAutomateDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ccm_automate_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CCMAutomateDialog), 0, (GInstanceInitFunc) ccm_automate_dialog_instance_init, NULL };
	ccm_automate_dialog_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "CCMAutomateDialog", &g_define_type_info, 0);
	return ccm_automate_dialog_type_id;
}



